// Version: Turkey

// HOW TO USE:
// in onLoad
//    include('sizegrips.js');
//
// in every object
//    <onMouseDown>activateGrips(objectName);</onMouseDown>
//    <onMouseMove>dragObject(objectName);</onMouseMove>
//    <onMouseUp>dragObjectRelease(objectName);</onMouseUp>

// (Optional #1) Add this function:
//    function localDragObjectRelease(currentObject){
//      //Insert code here. Ex: saving the new hOffset and vOffset into preferences
//    }

// (Optional #2) If you want to be able to resize a window:
//   
// In the background object, most likely the background image, add
//    <onMouseDown>activateGrips(objectName);</onMouseDown>
//    <onMouseMove>dragObject(mainWindow);</onMouseMove>
//    <onMouseUp>dragObjectRelease(mainWindow);</onMouseUp>
//

//       <onMouseDown>activateGrips(playPen);activatePegObject(area);</onMouseDown>


// and to enable auto resizing to the window, add this line:
//    sg_setBoundBox(mainWindow);
//
// Where mainWindow is the name of the window
// make sure that mainWindow has some width and height not equal to -1 if
// you are enabling auto resizing.
//
// Double click the top left grip to activate auto resizing
//
// Whenever possible, the script will try and set the bound box to the window, even if you didn't include the statements
//
// -congratulator widgets@angrysock.com http://angrysock.com/widget/SizeGrips.html



// CODE STARTS BELOW


function sg_limit(a,b,c){ return Math.max(Math.min(a,c),b); }

var sg_boundBox  = new Array(-1,-1,0,0);            // This is the I Don't Care default values
var sg_sourceDim = new Array();
var sg_draggableObjects;
var sg_draggableObjectsData;

// sg_boundBox
//
// Restricts movement to this box, defined as hOffset, vOffset, width, height
//   In the future, this can be used to restrict movement to another object
// If it's not set, it only keeps stuff from going negative 
// This thing is really messy... oh well.
//
function sg_setBoundBox(windowObject){
  if ((windowObject.width > 0) && (windowObject.height > 0)) {
    sg_boundBox = [0,0,windowObject.width - 1,windowObject.height - 1];
  }
}

// activateGrips
//
// turns on the grips and prepares to do work
//
function activateGrips(object){
  grippedObject = object;            // global variable grippedObject
  sg_dragObjectInit(object);         // prepare initial hOffsets so you can move the object
}
function updateGrips(object){
  sg_dragObjectInit(object);         // prepare initial hOffsets so you can move the object
}
function activatePegObject(object){
  peggedObject = object;
}
function sg_setSourceDimensionTo(width,height){
  sg_sourceDim = new Array(width,height);
  print("background width, height:",sg_sourceDim[0],sg_sourceDim[1]);
}
function sg_dragObjectInit(currentObject){
  sg_draggableObjects     = new Array();
  sg_draggableObjectsData = new Array(system.event.screenX, system.event.screenY);
  
  sg_draggableObjects.push(currentObject);
  //push more objects onto 'sg_draggableObjects' if you want them to move too      

  sg_draggableObjectsData.push(currentObject.hOffset);
  sg_draggableObjectsData.push(currentObject.vOffset);
}

// dragObject
//
// Takes all the objects in the array 'sg_draggableObjects' and moves them as one.
//
function dragObject(currentObject){
	for (var i=sg_draggableObjects.length-1;i>=0;--i){
   	sg_draggableObjects[i].hOffset = system.event.screenX + sg_draggableObjectsData[i*2+2] - sg_draggableObjectsData[0];
    if ((sg_boundBox[0] != -1) && (sg_draggableObjects[i].hOffset < sg_boundBox[0])) {
      sg_draggableObjects[i].hOffset = sg_boundBox[0];
    }
    if ((sg_boundBox[2] > 0) && (sg_draggableObjects[i].hOffset + sg_draggableObjects[i].width > sg_boundBox[2])) {
      sg_draggableObjects[i].hOffset = sg_boundBox[2] - sg_draggableObjects[i].width;
    }

		sg_draggableObjects[i].vOffset = system.event.screenY + sg_draggableObjectsData[i*2+3] - sg_draggableObjectsData[1];
    if ((sg_boundBox[1] != -1) && (sg_draggableObjects[i].vOffset < sg_boundBox[1])) {
      sg_draggableObjects[i].vOffset = sg_boundBox[1];
    }
    if ((sg_boundBox[3] > 0) && (sg_draggableObjects[i].vOffset + sg_draggableObjects[i].height > sg_boundBox[3])) {
      sg_draggableObjects[i].vOffset = sg_boundBox[3] - sg_draggableObjects[i].height;
    }
  }
}

var sg_deactivateGripsTimer;
// dragObjectRelease
//
// The work for this one gets done inside the main program.
//   It's just here to prevent errors by forcing everyone to use the same function name.
//
function dragObjectRelease(currentObject){
  preferences.width.value  = background.width;
  preferences.height.value = background.height;
  if (typeof(localDragObjectRelease) == "function") { localDragObjectRelease(currentObject); }
}



// ---------------GRIPS-------------------
var grippedObject;
var grippedObjectInitialDim;

// sg_activateGrip
//
// prepares to do work of changing the dimensions
//
// grippedObjectInitialDim = [width, height, hOffset, vOffset, mouseX, mouseY]
//
function sg_activateGrip(){
  grippedObjectInitialDim = new Array();
  grippedObjectInitialDim.push(grippedObject.width);
  grippedObjectInitialDim.push(grippedObject.height);
  grippedObjectInitialDim.push(grippedObject.hOffset);
  grippedObjectInitialDim.push(grippedObject.vOffset);
  grippedObjectInitialDim.push(system.event.screenX);
  grippedObjectInitialDim.push(system.event.screenY);
}

var grippedObjectInitialOpacity;
function sg_activateEye(){
  grippedObjectInitialOpacity = new Array();
  grippedObjectInitialOpacity.push(grippedObject.opacity);
  grippedObjectInitialOpacity.push(sg_opacityEye.hOffset);
  grippedObjectInitialOpacity.push(system.event.screenX);
}

function sg_dragEye(){
  if (String(grippedObject).search(/Window/) > 0) {
    sg_opacityEye.hOffset = sg_limit(grippedObjectInitialOpacity[1] + system.event.screenX - grippedObjectInitialOpacity[2],0,grippedObject.width - 1);
    grippedObject.opacity = Math.round(sg_opacityEye.hOffset / (grippedObject.width - 1) * 204) + 51;
  } else {
    sg_opacityEye.hOffset = sg_limit(grippedObjectInitialOpacity[1] - grippedObjectInitialOpacity[2] + system.event.screenX,grippedObject.hOffset,grippedObject.hOffset + grippedObject.width - 1);
    grippedObject.opacity = Math.round((sg_opacityEye.hOffset - grippedObject.hOffset) / (grippedObject.width - 1) * 204) + 51;
  }
  sg_opacityEye.hslAdjustment="0, " + Math.round(grippedObject.opacity/255*200-100) + ", " + Math.round(grippedObject.opacity/255*150-100);
}

// RESIZE OBJECT
function sg_dragGrip(gripDirection){
  var direction = gripDirection;
  //print(gripObject.name,direction);
  var deltaMouseX = grippedObjectInitialDim[4] - system.event.screenX;
  var deltaMouseY = grippedObjectInitialDim[5] - system.event.screenY; 
  if (/N/.test(direction)) {
    if ((sg_boundBox[1] != -1) && (grippedObjectInitialDim[3] - deltaMouseY < sg_boundBox[1])) {
      deltaMouseY = grippedObjectInitialDim[3] - sg_boundBox[1];
    }
    grippedObject.height  = grippedObjectInitialDim[1] + deltaMouseY;
    grippedObject.vOffset = grippedObjectInitialDim[3] - deltaMouseY;
  } else if (/S/.test(direction)) {
    if ((sg_boundBox[3]) && (grippedObjectInitialDim[3] + grippedObjectInitialDim[1] - deltaMouseY >= sg_boundBox[3])) {
      deltaMouseY = grippedObjectInitialDim[3] + grippedObjectInitialDim[1] - sg_boundBox[3];
    }
    grippedObject.height = grippedObjectInitialDim[1] - deltaMouseY;
  }
  if (/W/.test(direction)) {
    if ((sg_boundBox[0] != -1) && (grippedObjectInitialDim[2] - deltaMouseX < sg_boundBox[0])) {
      deltaMouseX = grippedObjectInitialDim[2] - sg_boundBox[0];
    }
    grippedObject.width   = grippedObjectInitialDim[0] + deltaMouseX;
    grippedObject.hOffset = grippedObjectInitialDim[2] - deltaMouseX;
  } else if (/E/.test(direction)) {
    if ((sg_boundBox[2]) && (grippedObjectInitialDim[2] + grippedObjectInitialDim[0] - deltaMouseX >= sg_boundBox[2])) {
      deltaMouseX = grippedObjectInitialDim[2] + grippedObjectInitialDim[0] - sg_boundBox[2];
    }
    grippedObject.width = grippedObjectInitialDim[0] - deltaMouseX;
  }
  if (peggedObject) {
    peggedObject.width  = grippedObject.width;
    peggedObject.height = grippedObject.height;
  }
  updateLayout();  // CRCCHECK
}

// deactivateGrips
//
// I don't know how to call this yet. onMouseExit does it prematurely.
//   Maybe using a timer? or chaining multiple onMouseExit events?
//
function deactivateGrips(object){
  delete gripN;
  delete gripS;
  delete gripE;
  delete gripW;
  delete gripNE;
  delete gripNW;
  delete gripSE;
  delete gripSW;
  delete sg_opacityEye;
  peggedObject = "";
}

var peggedObject;

// TO DO:
// sg_boundBox troubles 

// UNDO. It works, but too much trouble to do, since the hotkey is active all the time.
//sg_undo = new Hotkey();
//sg_undo.key = "Z";
//sg_undo.modifier = "control";
//sg_undo.onKeyDown= "undoLastMoveSize();";
