// STABLER, OLDER CODE
function limit(a,b,c){ return Math.max(Math.min(a,c),b); }

function RGB(r,g,b){
  this.ease = function(newRGB,pct){
    var newR = this.r + Math.round((newRGB.r - this.r)*pct);
    var newG = this.g + Math.round((newRGB.g - this.g)*pct);
    var newB = this.b + Math.round((newRGB.b - this.b)*pct);
    return new RGB(newR,newG,newB);
  }
  this.hex = function(){
    var rhex, ghex, bhex;
    
    if ((rhex=this.r.toString(16)).length < 2) {rhex = "0"+rhex;}
    if ((ghex=this.g.toString(16)).length < 2) {ghex = "0"+ghex;}
    if ((bhex=this.b.toString(16)).length < 2) {bhex = "0"+bhex;}
    
    return "#"+rhex+ghex+bhex;
  }
  this.hexInput = function(hex){
    this.r=parseInt(hex.substring(1,3),16);
    this.g=parseInt(hex.substring(3,5),16);
    this.b=parseInt(hex.substring(5,7),16);
  }
  switch (arguments.length) {
    case 3 :
      this.r = r;
      this.g = g;
      this.b = b;
      break;
    case 1 :
      this.hexInput(r);
      break;
    default:
      log('RGB called with improper number of arguments. Got ' + arguments.length);
  }
}

function raiseButtons(){
  var a = new FadeAnimation( sidebarR  , themeData.buttonOnOpacity , themeData.buttonOffOpacity , animator.kEaseIn );
  var b = new FadeAnimation( sidebarR2 , themeData.buttonOnOpacity , themeData.buttonOffOpacity , animator.kEaseIn );
  var c = new FadeAnimation( sidebarL  , themeData.buttonOnOpacity , themeData.buttonOffOpacity , animator.kEaseIn );
  animator.start(new Array(a,b,c));
}

function lowerButtons(){
  var a = new FadeAnimation( sidebarR  , themeData.buttonOffOpacity , themeData.buttonOnOpacity , animator.kEaseIn );
  var b = new FadeAnimation( sidebarR2 , themeData.buttonOffOpacity , themeData.buttonOnOpacity , animator.kEaseIn );
  var c = new FadeAnimation( sidebarL  , themeData.buttonOffOpacity , themeData.buttonOnOpacity , animator.kEaseIn );
  animator.start(new Array(a,b,c));
}

HotKey.prototype.setHotKey = function(para){    // this snippet from Drevor, very clever
  if ((para === undefined) || (para == "")) { return log("HotKey preferences String not defined"); }
  para = String(para).split("+");
  var key = para.pop();
  for (var i = para.length - 1; i >= 0; --i) {
    if (para[i] == "Alt")        { para[i] = "Shift"; }
    else if (para[i] == "Shift") { para[i] = "Alt"; }
  }
  var mod=para.join("+");
  this.modifier = mod;
  this.key      = key;
  //    log("key: "+key+"("+this.key+") / modifier: "+mod+"("+this.modifier+")");
}

function doOnKeyPress(){
  if (state == "showtime") {
    // This block will handle random keypresses. ENTER, ESC, BACKSPACE
    switch(system.event.key.charCodeAt(0)){
      case 27:                             // ESC
        appSearch.rejectKeyPress();
        if (appSearch.data == ""){ toState("ready"); }
        else { toState("showtime"); }
        break;
      case 8:                              // BACKSPACE
        oldAppSearch = "";                 // this will force a reset of filteredAppList
        break;
      default:                             // EVERYTHING ELSE
        oldAppSearch = appSearch.data;
        break;
    }
    keyDebug = true;
    //print("DEBUG onKeyPress:",system.event.key.charCodeAt(0),system.event.keyString,"old:",oldAppSearch,"new:",appSearch.data);
    autoSleep.reset();                     // reset inactivity timer
  }
}

function doOnKeyUp(){
  if (state == "showtime") {
    appSearch.data = appSearch.data.replace(/[\n\r]/g,"");                  // in case any line breaks snuck in, get rid of them

    if ((oldAppSearch === "") || (appSearch.data.search(oldAppSearch) == -1)) {
      // RESET FILTERED LIST
      filteredAppList     = new Array();
      filteredAppListName = new Array();
      filteredAppList     = filteredAppList.concat(fullAppList);
      filteredAppListName = filteredAppListName.concat(fullAppListName);
    }
    // FILTER OUT BAD STUFF
    var appSearchRegEx = new RegExp(appSearch.data,"i");
    for (var i = filteredAppListName.length - 1;i>=0;--i){
      if (!appSearchRegEx.test(filteredAppListName[i])) { filteredAppListName.splice(i,1); filteredAppList.splice(i,1); }      
    }
    resultsTotal.data = filteredAppListName.length;
    
    // UPDATE UI
    var pos = selectedApp.current;
    var displayListLength = Math.min(rowsInList*colsInList,filteredAppListName.length);
    if (keyDebug) {
      fillDisplayList(displayListLength);      // means onKeyPressed was triggered before
      selectedApp.current = (pos < appResults.length)? pos : 0;
    }

    // move selection around
    switch (system.event.keyString) {
      case "LeftArrow":
        selectedApp.moveLeft(displayListLength);
        oldAppSearch = appSearch.data;
        break;
      case "RightArrow":
        selectedApp.moveRight(displayListLength);
        oldAppSearch = appSearch.data;
        break;
      case "UpArrow":
        selectedApp.moveUp(displayListLength);
        oldAppSearch = appSearch.data;
        break;
      case "DownArrow":
        selectedApp.moveDown(displayListLength);
        oldAppSearch = appSearch.data;
        break;
      case "Return":
        updateNow();
        eval(appResults[selectedApp.current].frame.onMouseUp);
        break;
    }
    keyDebug = false;
  }
}

// OBJECT: selection object
function AppSelector(initialPosition){
  this.current = initialPosition;
  this.watch("current",
      function(prop, oldval, newval)  {
        excitedIcon.ticking = true;
        //print("selecting position: " + newval + " old position: " + oldval);
        if (appResults[newval] !== undefined) {
          appResults[newval].bg.bgOpacity = themeData.selectOpacity;
          appResults[newval].bg.bgColor   = themeData.selectColor;
          appPath.data = filteredAppList[newval];
        }
        if ((oldval !== undefined) && (oldval !== newval) && (appResults[oldval] !== undefined)) {
          appResults[oldval].bg.bgOpacity = appResults[oldval].bg.bgOpacityA;
          appResults[oldval].bg.bgColor   = appResults[oldval].bg.bgColorA;
          appResults[oldval].icon.rotation = 0;
        }
        return newval;
      }
  );

  this.moveLeft = function(maxLen){
    if (maxLen) {
      var newPos = this.current - 1;
      if (newPos < 0) { newPos += maxLen; } // maxLen or rowsInList * colsInList ... oh well
      this.current = newPos;
    }
  }
  this.moveRight = function(maxLen){
    if (maxLen) {
      var newPos = this.current + 1;
      if (newPos > (maxLen - 1)) { newPos -= maxLen; }
      this.current = newPos;
    }
  }
  this.moveUp = function(maxLen){
    if (maxLen) {
      var newPos = this.current - colsInList;
      if (newPos < 0) { newPos += maxLen; }
      this.current = newPos;
    }
  }
  this.moveDown = function(maxLen){
    if (maxLen) {
      var newPos = this.current + colsInList;
      if (newPos > (maxLen - 1)) { newPos -= maxLen; }
      this.current = newPos;
    }
  }
}

// FILTER APP LIST
//
// Takes the array and removes the stuff we're not interested in.
// I could work on the global var, but I figure it's good practice to pass by reference
//
function filterAppList(appList,iregexp,eregexp) {
  var tmpAppListEntry;
  for (var i = appList.length-1; i >= 0;--i) {
    tmpAppListEntry = appList[i];
    if (
        (tmpAppListEntry.search(iregexp) == -1) ||
        (tmpAppListEntry.search(eregexp) != -1) ||
        (!filesystem.itemExists(tmpAppListEntry))
       )
     { appList.splice(i,1); }      
  }
}

// APP NAME FROM PATH / GET EXTENSION  
// 
// see Ukki
//
function appNameFromPath(inputPath) {
  var pos1 = inputPath.lastIndexOf('/');      var pos2 = inputPath.lastIndexOf('.');
  return (pos2 < pos1)? inputPath.substr(pos1 + 1) : inputPath.substr(pos1 + 1,pos2 - pos1 - 1);
}
function getExtension(path) {
  var pos = path.lastIndexOf('.');
  return (pos < 0)? "" : path.substr(pos + 1);
}
function getParentDirectory(path) {
  var pos = path.lastIndexOf('/');
  return (pos < 0)? "" : path.substr(0,pos);
}
// SYNCHRONIZE NAMES FROM PATH
//
// not sure what's going on over here, but it works
// is the array being handled poorly? am I making copies I could be avoiding?
//
function nameArrayFromPathArray(pathArray) {
  var nameArray = new Array();
  for (var i = pathArray.length - 1; i >= 0 ; --i) { nameArray[i] = (appNameFromPath(pathArray[i])); }
  return nameArray;
}

// ADD FULL PATH
//
// This is how I make sure that the array is full of the entire path instead of relative paths
// I could sure use the forEach array iteration method
//
function addFullPath(arrayOfPartialPaths,prefix) {
  for (var i = arrayOfPartialPaths.length-1; i >= 0; --i) { arrayOfPartialPaths[i] = prefix + arrayOfPartialPaths[i]; }
  return arrayOfPartialPaths;
}

// READ/WRITE APP LIST FROM/TO DISK
//
// stores the app list between sessions
//
function readAppListFromDisk(){
  if (filesystem.itemExists(system.widgetDataFolder + "/applist.txt")) {
    fullAppList = filesystem.readFile(system.widgetDataFolder + "/applist.txt",true);
    print("I/O: previous app list found and loaded from disk");
  } else { print("I/O: previous app list not found"); }
}
function writeAppListToDisk(){
  filesystem.writeFile(system.widgetDataFolder + "/applist.txt",fullAppList);
  if (filesystem.itemExists(system.widgetDataFolder + "/applist.txt")) { print("I/O: app list written to disk"); }
  else { print("I/O: app list not written to disk!"); }
}

// SCAN START BAR
//
function scanStartBar(){
  if (preferences.startbar.value == "1") {
    print("scanStartBar : querying the registry to find the start bar location");
    var userStartMenuBase, allStartMenuBase;
    var command = runCommand('cscript //nologo "Resources/IH8MS.vbs"');
    var dirs = command.split(/\n/);
    print(dirs);
    if (dirs.length == 2) {
      userStartMenuBase = dirs[0].replace(/\\/g,"/");    // enforce unix style paths
      allStartMenuBase  = dirs[1].replace(/\\/g,"/");    // enforce unix style paths
  
      //var command = runCommand('reg query "HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders" /v "Programs"');
      //userStartMenuBase = command.match(/(REG_SZ\s*)(.*$)/m)[2].replace(/\\/g,"/");    // enforce unix style paths
  
      //command = runCommand('reg query "HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders" /v "Common Programs"');
      //allStartMenuBase  = command.match(/(REG_SZ\s*)(.*$)/m)[2].replace(/\\/g,"/");    // enforce unix style paths
  
      // ASSUME WE FOUND START MENUS FOR NOW
      
      // ADD PATHS FOUND FROM SCANNING THE DIRECTORIES
      print("FOUND: " + userStartMenuBase);
      print("FOUND: " + allStartMenuBase);
      var startbarAppList = addFullPath(filesystem.getDirectoryContents(userStartMenuBase,true),userStartMenuBase + "/");
      startbarAppList = startbarAppList.concat(addFullPath(filesystem.getDirectoryContents(allStartMenuBase,true),allStartMenuBase + "/"));
      
      print("F,S: ",fullAppList.length,startbarAppList.length,"looking for new entries");
      filterAppList(startbarAppList,/\.lnk$/i,/uninstall|readme|\shelp/i);        // filter new entries
      print("Entries to add: ",startbarAppList.length);
  
      // look and add new entries
      var j;
      for (var i = startbarAppList.length-1;i >= 0;--i){
        j = fullAppList.length - 1;
        while ((j >= 0) && (fullAppList[j] != startbarAppList[i])) { --j; }
        if (j < 0) { fullAppList.push(startbarAppList[i]); }
      }
      print("Total: ",fullAppList.length);
    } else {
      alert("Couldn't find your start menu, disabling this feature");
      preferences.startbar.value == "0";
    }

  }
  fullAppListName = nameArrayFromPathArray(fullAppList);
}

function scanDirs(){
  var basedir;
  var newAppList = new Array();
  var foundAppList;// = new Array();
  var extlist;
  var iregexp,eregexp;

  for (var i = 1; i <= 4; ++i){   // there are 4 user definable directory
    basedir = preferences["dir" + i].value;
    if (filesystem.isDirectory(basedir)) {
      print("starting seach of " + basedir);
      foundAppList = addFullPath(filesystem.getDirectoryContents(basedir,true),basedir + "/");
      if (extlist = preferences["dirext" + i].value.replace(/\s/g,"")) {
        extlist = extlist.replace(/\,/,"|");                                    // easy conversion
        iregexp = new RegExp("\.(" + extlist + ")$","i");
      }
      else iregexp = new RegExp(".*");
      eregexp = new RegExp(preferences.filter.value.replace(/\,/,"|"));         // convert commas to pipes
      filterAppList(foundAppList,iregexp,eregexp);
      newAppList = newAppList.concat(foundAppList);
      print("Now: " + foundAppList.length + " entries to go through, " + newAppList.length + " to be added");
    }
  }

  print("scanDirs : F,S: ",fullAppList.length,newAppList.length);

  // look and add new entries
  var j;
  for (i = newAppList.length-1;i >= 0;--i){
    j = fullAppList.length - 1;
    while ((j >= 0) && (fullAppList[j] != newAppList[i])) { --j; }
    if (j < 0) { fullAppList.push(newAppList[i]); }
  }
  print("scanDirs : F,S: ",fullAppList.length,newAppList.length);
  fullAppListName = nameArrayFromPathArray(fullAppList);
}

function deleteProgram(indexOfApplist){                 // TODO: fix this
  var deleteThis = filteredAppList[indexOfApplist];
  print('filesystem.moveToRecycleBin("' + deleteThis + '")');
  filesystem.moveToRecycleBin(deleteThis);
  //remove item from filteredAppList
  filteredAppList.splice(indexOfApplist,1);
  filteredAppListName.splice(indexOfApplist,1);
  //remove item from fullapplist... search for it
  var i = fullAppList.length-1;
  while ((i >= 0) && (fullAppList[i] != deleteThis)){ --i; }
  if (i != -1) {
    fullAppList.splice(i,1);
    fullAppListName.splice(i,1);
    writeAppListToDisk();
  }
  fillDisplayList(Math.min(rowsInList*colsInList,filteredAppList.length));
}

function launchProgram(pathToProgram){
  // DO LAUNCH ANIMATION
  clearAllCells();
  updateNow();
  // LAUNCH PROGRAM
  print("launchProgram() : LAUNCH!! " + pathToProgram);
  switch (getExtension(pathToProgram)) {
    case "lnk" :
      var result = runCommand("\"" + pathToProgram.replace(/'/,"\'") + "\"");    // make slashes consistent 
      print("runCommand result: " + result);
        if (result) { alert("Error Occured: " + result);
        appPath.data = result;
      }
      updateNow();
      break;
    default :
      filesystem.open(pathToProgram);
  }
  // RE-ORDER LIST TO PUT ENTRY AT THE TOP
  var i = fullAppList.length-1;
  while ((i > 0) && (fullAppList[i] != pathToProgram)){ --i; }         // don't bother searching the 1st entry
  if (i > 0) {
    fullAppList.splice(i,1);
    var nameOfProgram = fullAppListName[i];
    fullAppListName.splice(i,1);
    //print("reordering fullAppList: " + nameOfProgram + " , " + i);
    fullAppList.unshift(pathToProgram); fullAppListName.unshift(nameOfProgram);
    writeAppListToDisk();
  }
  if (!result) toState("ready");
}

function updateAppList(){
  toState("working");
  appPath.data = "Updating App List... Please Wait";
  updateNow();
  scanStartBar();
  scanDirs();
  filterAppList(fullAppList,/./);       // look for deleted entries 
  appPath.data = "Updating App List... Please Wait... Done!";
  updateNow();
  toState("showtime");
}
function resetAppList(){
  toState("working");
  appPath.data = "Resetting App List... Please Wait";
  updateNow();
  fullAppList = new Array();
  scanStartBar();
  scanDirs();
  appPath.data = "Updating App List... Please Wait... Done!";
  updateNow();
  toState("showtime");
}

// THEME CONTROL

function loadTheme(){
  print("Reading Layout...");
  var ini = "Resources/" + preferences.theme.value + "/lay.out";
  var file = filesystem.readFile(ini,true);
  var lines = file.length;
  var sectionText = new RegExp("^\\[(.*)\\]$","m");
  var commentText = new RegExp("^;");
  var section =  '';
  var item = '';
  var data = '';
  for (var i = 0; i < lines; ++i){
    if (commentText.test(file[i])) { }
    else if (sectionText.test(file[i])) {
      sectionName = file[i].match(sectionText)[1];
      section = eval(sectionName);
    }
    else if ((ioe = file[i].indexOf('=')) != -1) {
      var item = file[i].substring(0,ioe).replace(/\s+$/,'');
      var data = file[i].substr(ioe+1).replace(/^\s+/,'');
      print("- " + sectionName + "." + item + "=" + data);
      section[item] = data;
    }
    else {
    
    }
  }
  background.src = "Resources/" + preferences.theme.value + "/ll*.png";
  loadTheme_buttons();
  updateLayout();
}

function loadTheme_buttons(){
  var theme = preferences.theme.value;
  // BUTTON BACKGROUNDS / BLANKS
  var tempImgLoc;
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt.png"))? preferences.theme.value : "default") + "/butt.png";
  sidebarL_b1_bg.src = tempImgLoc;
  sidebarL_b2_bg.src = tempImgLoc;
  sidebarL_b3_bg.src = tempImgLoc;
  sidebarL_b4_bg.src = tempImgLoc;
  sidebarR_b1_bg.src = tempImgLoc;
  sidebarR_b2_bg.src = tempImgLoc;
  sidebarR2_b1_bg.src = tempImgLoc;
  sidebarR2_b2_bg.src = tempImgLoc;
  sidebarR2_b3_bg.src = tempImgLoc;
  sidebarR2_b4_bg.src = tempImgLoc;
  
  var currentButt = "add1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  add.src = tempImgLoc;

  currentButt = "refresh1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  refresh.src = tempImgLoc;

  currentButt = "modes1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  modeS.src = tempImgLoc;
  currentButt = "model1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  modeL.src = tempImgLoc;
  currentButt = "moded1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  modeD.src = tempImgLoc;
  currentButt = "modet1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  modeT.src = tempImgLoc;

  currentButt = "xlargeicon1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  iconsX.src = tempImgLoc;
  currentButt = "largeicon1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  iconsL.src = tempImgLoc;
  currentButt = "smallicon1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  iconsS.src = tempImgLoc;
  currentButt = "noicon1";
  tempImgLoc = "Resources/" + ((filesystem.itemExists("Resources/" + preferences.theme.value + "/butt" + currentButt + ".png"))? preferences.theme.value : "default") + "/butt" + currentButt + ".png";
  iconsN.src = tempImgLoc;

  sidebarL.opacity = sidebarR.opacity = sidebarR2.opacity = themeData.buttonOffOpacity;
  
  if (sidebarL.spacing !== undefined) {
    iconsX.vOffset = sidebarL_b1_bg.vOffset = 0;
    iconsL.vOffset = sidebarL_b2_bg.vOffset = iconsX.vOffset + iconsX.height + parseInt(sidebarL.spacing,10);
    iconsS.vOffset = sidebarL_b3_bg.vOffset = iconsL.vOffset + iconsX.height + parseInt(sidebarL.spacing,10);
    iconsN.vOffset = sidebarL_b4_bg.vOffset = iconsS.vOffset + iconsX.height + parseInt(sidebarL.spacing,10);
  }
  if (sidebarR.spacing !== undefined) {
    add.vOffset     = sidebarR_b1_bg.vOffset = 0;
    refresh.vOffset = sidebarR_b2_bg.vOffset = add.vOffset + add.height + parseInt(sidebarR.spacing,10);
  }
  if (sidebarR2.spacing !== undefined) {
    modeS.vOffset = sidebarR2_b1_bg.vOffset = 0;
    modeL.vOffset = sidebarR2_b2_bg.vOffset = modeS.vOffset + modeS.height + parseInt(sidebarR2.spacing,10);
    modeD.vOffset = sidebarR2_b3_bg.vOffset = modeL.vOffset + modeL.height + parseInt(sidebarR2.spacing,10);
    modeT.vOffset = sidebarR2_b4_bg.vOffset = modeD.vOffset + modeD.height + parseInt(sidebarR2.spacing,10);
  }
}
